<template>
  <CommandExecuteContext v-bind:commands="commandContext"></CommandExecuteContext>
</template>

<script>
  import TopologicalDynamicService from '@/domain/services/Business/TopologicalDynamicService.js'
  import HelperUtil from"../../../utils/HelperUtil";
  import UserCommands from "../../../commands/UserCommands"
  import CommandExecuteContext from '../../../commands/CommandExecuteContext'
  import UserService from '../../../domain/services/UserService.js'
  export default {
    props: ['command'],
    components: {
      CommandExecuteContext,
    },
    data:function () {
      return {
        deleteList: this.command.target,
        //命令
        commandContext: {},

        confirmFlag: {
          confirm: false,
        },
      }
    },
    methods: {
      close(){
        this.command.done()
      },

      open() {
        let _this = this;
        _this.InfoTip.conformTip(_this, HelperUtil.getCheckStatusCodeObjectByCode(_this.successCode.DELETE_CONFIRM)
        ).then(() => {
          this.deleteTopological();
      }).catch(()=>{
          this.close()
      });
      },

      //删除设备
      deleteTopological() {
        TopologicalDynamicService.deleteTopologicalDynamic(JSON.stringify(this.deleteList)).then(result => {
          this.InfoTip.successTip(this,HelperUtil.getStatusCodeObjectByCode(this.successCode.DELETE_CODE));
        this.close()
      }).catch(err => {
          this.InfoTip.errorTip(this,err);
        this.close()
      })
      }
    },

    watch: {
      commandContext (newVal, oldVal){
        let _this = this;
        if(_this.confirmFlag.confirm){
          this.open();
          this.confirmFlag.confirm = false
        }
        else{
          if(JSON.stringify(newVal) === '{}'){
            _this.close()
          }
        }
        deep: true
      },
    },

    created() {
      this.confirmUserCommand.execute();
    },

    computed: {
      confirmUserCommand(){
        this.confirmFlag.confirm = false;
        return UserCommands.confirmUserCommand(this.commandContext, this.confirmFlag)
      },
    },

  }
</script>
